/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// TriggerTemplate the model 'TriggerTemplate'
type TriggerTemplate string

// List of TriggerTemplate
const (
	TRIGGER_TAP_TO_INTERACT TriggerTemplate = "tap_to_interact"
	TRIGGER_INCOMING_MESSAGE TriggerTemplate = "incoming_message"
	TRIGGER_EVENT TriggerTemplate = "event"
	TRIGGER_PARTNER_LINK TriggerTemplate = "partner_link"
	TRIGGER_ENROLLMENT TriggerTemplate = "enrollment"
	TRIGGER_CAMPAIGN TriggerTemplate = "campaign"
	TRIGGER_AUTORESPONDER TriggerTemplate = "autoresponder"
	TRIGGER_EMPTY TriggerTemplate = ""
)

// All allowed values of TriggerTemplate enum
var AllowedTriggerTemplateEnumValues = []TriggerTemplate{
	"tap_to_interact",
	"incoming_message",
	"event",
	"partner_link",
	"enrollment",
	"campaign",
	"autoresponder",
	"",
}

func (v *TriggerTemplate) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := TriggerTemplate(value)
	for _, existing := range AllowedTriggerTemplateEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid TriggerTemplate", value)
}

// NewTriggerTemplateFromValue returns a pointer to a valid TriggerTemplate
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewTriggerTemplateFromValue(v string) (*TriggerTemplate, error) {
	ev := TriggerTemplate(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for TriggerTemplate: valid values are %v", v, AllowedTriggerTemplateEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v TriggerTemplate) IsValid() bool {
	for _, existing := range AllowedTriggerTemplateEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to TriggerTemplate value
func (v TriggerTemplate) Ptr() *TriggerTemplate {
	return &v
}

type NullableTriggerTemplate struct {
	value *TriggerTemplate
	isSet bool
}

func (v NullableTriggerTemplate) Get() *TriggerTemplate {
	return v.value
}

func (v *NullableTriggerTemplate) Set(val *TriggerTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableTriggerTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableTriggerTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTriggerTemplate(val *TriggerTemplate) *NullableTriggerTemplate {
	return &NullableTriggerTemplate{value: val, isSet: true}
}

func (v NullableTriggerTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTriggerTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

